#include <lwserver.h>            /* all plug-ins need this        */
#include <lwgeneric.h>           /* for the LayoutGeneric class   */
#include <lwpanel.h>             /* for "classic" panels          */
#include <lwrender.h>             /* for "classic" panels          */
#include <lwhost.h>              /* for the LWMessageFuncs global */
#include <stdio.h>               /* for NULL #define              */
#include <string.h>
#include <lwsurf.h>

LWMessageFuncs *msg;             /* the message functions         */
LWPanelFuncs *panf;              /* the panel functions           */
LWPanelID panel;                 /* the panel                     */
LWControl *ctl;                  /* a control on the panel        */
LWPanControlDesc desc;           /* used by macros in lwpanel.h   */
LWViewportInfo	*vpinfo				= NULL;	
LWObjectInfo *lwo;
   LWSceneInfo *lws;
   LWItemInfo *lwi;
   LWInterfaceInfo *lwint;
   LWCameraInfo *lwc;
 LWChannelInfo *chinfo;
 LWEnvelopeFuncs *env;
LWSurfaceFuncs *srff;
LWValue sval = { LWT_STRING };   /*  read lwpanel.h to see how    */
char edit[ 512 ] =                /* string for the edit control   */
   "This is an edit field.";


typedef struct st_Polyparse {
	LWItemID Iid;
	FILE *fp;
} Polyparse;


	int rwidth,rheight;




char *rgbtoweb(int r,int g, int b)
{
	char cm[256];
//int rgbNum = ((r & 0xff) << 16) | ((g & 0xff) << 8)	| (b & 0xff);
//return ConvertRGBtoHex(rgbNum);
	sprintf(cm,"%02X%02X%02X",r,g,b);
	return cm;
}


static int polScan(Polyparse *pp, LWPolID id )
{
	int t,pointnum;
	LWMeshInfo *mesh;
	char surface[512];
	double *col,*trans;
	double ttrans,tcol[3]; 
	LWSurfaceID *Sid;
	int left, top, width, height,xxwidth,xxheight;

	mesh = lwo->meshInfo(pp->Iid, 1);

	Sid = srff->byName( mesh->polTag( mesh, id, LWPTAG_SURF ), lwo->filename(pp->Iid) );
	if(Sid)
	{
		col = srff->getFlt(Sid[0],SURF_COLR);
		trans = srff->getFlt(Sid[0],SURF_TRAN);
		ttrans = *trans;
		tcol[0] = col[0];
		tcol[1] = col[1];
		tcol[2] = col[2];


		fprintf(pp->fp,"       <path\n");
		fprintf(pp->fp,"           style=\"fill:#%s;fill-opacity:%f;stroke:#ffffff;stroke-width:0;stroke-miterlimit:4;stroke-dashoffset:0;stroke-opacity:1\"\n",rgbtoweb(col[0]*255,col[1]*255, col[2]*255),1 - ttrans);
		fprintf(pp->fp,"              d=\"m ");

		
    vpinfo->rect(0, &left, &top, &width, &height);


				xxwidth = width;
				xxheight =height;



		pointnum = mesh->polSize(mesh,id);
		for(t=0; t< pointnum;t++)
		{
			LWPntID pID;
			LWFVector pos;
			LWDVector dpos;
			double x,y,z,xx,yy;
			double xres,yres;
			pID = mesh->polVertex( mesh, id, t );
			mesh->pntOtherPos( mesh, pID, pos );
			dpos[0] = pos[0];dpos[1] = pos[1];dpos[2] = pos[2];
			vpinfo->project(0, dpos, &x, &y, &z);

			if(vpinfo->type == LVVIEWT_CAMERA)
			{
				//TODO: Correlate aspect ratio of cam with aspect ratio
				//of the screen to get the correct borders / camsize
				xx= ((x)/(double)width)*xxwidth;
				yy= ((y)/(double)height)*xxheight;
			}
			else
			{
				xx= ((x)/(double)width)*xxwidth;
				yy= ((y)/(double)height)*xxheight;
			}
			if(t > 0)
			{
				fprintf(pp->fp," L",xx,yy);
			}
			fprintf(pp->fp," %f,%f",xx,yy);
		}
		fprintf(pp->fp," z\"\n");
		fprintf(pp->fp,"/>\n");
	}
   return 0;
}



XCALL_( int )
ExportSVG( int version, GlobalFunc *global, LWLayoutGeneric *local,
   void *serverData )
{
   int ok;
   char cm[512];
	FILE *fp;
   LWItemID id;
   int left, top, rwidth, rheight;
   if ( version != LWLAYOUTGENERIC_VERSION )
      return AFUNC_BADVERSION;

   /* get the message and panels functions */

   msg = (LWMessageFuncs *)global( LWMESSAGEFUNCS_GLOBAL, GFUSE_TRANSIENT );
   panf = (LWPanelFuncs *)global( LWPANELFUNCS_GLOBAL, GFUSE_TRANSIENT );
   msg = (global) ( LWMESSAGEFUNCS_GLOBAL, GFUSE_TRANSIENT );
   panf = (global)( LWPANELFUNCS_GLOBAL, GFUSE_TRANSIENT );
   srff = (global) ( LWSURFACEFUNCS_GLOBAL, GFUSE_TRANSIENT );
   lws = (global) ( LWSCENEINFO_GLOBAL, GFUSE_TRANSIENT );
   lwi = (global) ( LWITEMINFO_GLOBAL, GFUSE_TRANSIENT );
   lwo = (global) ( LWOBJECTINFO_GLOBAL, GFUSE_TRANSIENT );
   env =  (global)( LWENVELOPEFUNCS_GLOBAL, GFUSE_TRANSIENT );
   chinfo = (global)( LWCHANNELINFO_GLOBAL, GFUSE_TRANSIENT );
   lwint = (global)( LWINTERFACEINFO_GLOBAL, GFUSE_TRANSIENT );
	vpinfo =  (global) (LWVIEWPORTINFO_GLOBAL, GFUSE_TRANSIENT);
	lwc = global( LWCAMERAINFO_GLOBAL, GFUSE_TRANSIENT );





   if ( !msg || !panf )
      return AFUNC_BADGLOBAL;
	id = lws->renderCamera(lwint->curTime);
	lwc->resolution(id,&rwidth,&rheight);	
   /* initialize the panels functions and create a panel */

   panf->globalFun = global;

   panel = PAN_CREATE( panf, "tibe3 export current frame as SVG" );
   if ( !panel ) return AFUNC_BADGLOBAL;

   /* create an edit field on the panel and initialize its contents */

   ctl = FILE_CTL( panf, panel, "File", 30 );


   /* display the panel; this waits until the user closes it */

   /* ok is TRUE if the user pressed OK, FALSE if he or she pressed Cancel */

	if ( panf->open( panel, PANF_BLOCKING | PANF_CANCEL ))
	{
        GET_STR( ctl, edit, sizeof( edit ));
	}
	else
	{
		return AFUNC_OK;
	}


   /* free the panel */

   PAN_KILL( panf, panel );
	if (strlen(edit) < 2)
	{
		return AFUNC_OK;
	}

	//SVG TAG
   fp = fopen(edit,"w");
   fprintf(fp,"<?xml version=\"1.0\" encoding=\"UTF-8\" standalone=\"no\"?>\n");
   fprintf(fp,"<!-- Created in LightWave with tibe3 SVG export (http://www.splotchdog.com/) -->\n\n");

   fprintf(fp,"<svg\n");

   fprintf(fp,"xmlns=\"http://www.w3.org/2000/svg\" xmlns:xlink=\"http://www.w3.org/1999/xlink\"\n");
   //TODO USE THE CORRECT VALUES FOR CAMERA
    vpinfo->rect(0, &left, &top, &rwidth, &rheight);
   fprintf(fp,"width=\"%ipx\"\n",rwidth);

   fprintf(fp,"height=\"%ipx\"\n",rheight);

   fprintf(fp,"id=\"svg2\"\n");

   fprintf(fp,"version=\"1.1\">\n");


	id = lwi->first(LWI_OBJECT,NULL);
	while(id)
	{
		LWMeshInfo *mesh;
		mesh = lwo->meshInfo( id, 1 );	
	//for each object add a group
	//and scan the polygons	
		if(mesh != NULL)
		{
			if(mesh->numPoints > 2)
			{
				Polyparse polparse;
				polparse.fp = fp;
				polparse.Iid = id;
				fprintf(fp,"    <g>\n");
				mesh->scanPolys( mesh, polScan, &polparse );
				fprintf(fp,"    </g>\n");
			}
		}
		id = lwi->next(id);
		
	}

   fprintf(fp,"</svg>\n");
	fclose(fp);


   return AFUNC_OK;
}


/*
======================================================================
This is the server description.  LightWave looks at this first to
determine what plug-ins the file contains.  It lists each plug-in's
class and internal name, along with a pointer to the activation
function.  You can optionally add a user name, or more than one in
different languages, if you like.
====================================================================== */

ServerRecord ServerDesc[] = {
   { LWLAYOUTGENERIC_CLASS, "tibe3_exportSVG", ExportSVG },
   { NULL }
};
